//
//  AEK2OverlayDocument.h
//  Apple Extended Keyboard II Overlay Generator
//
//  Created by Peter Hosey on 2008-05-03.
//  Copyright 2008 Peter Hosey. All rights reserved.
//

@class AEK2Overlay;

@interface AEK2OverlayDocument : NSDocument {
	IBOutlet NSObjectController *overlayController;
	//Lazily created and populated for printing purposes.
	NSImageView *imageView;

	AEK2Overlay *overlay;
	NSPropertyListFormat format;
}

//The font to use for the key-cap forms in the UI.
//Note that the EPS file also determines the font separately; this *only* affects the forms in the UI.
- (NSFont *) keyCapFont;

#pragma mark Actions

- (IBAction) saveEPSFileAs:sender;
- (IBAction) savePDFFileAs:sender;

@end
