//
//  NSObject+MapKVCKeysToDictionaryKeys.m
//  Apple Extended Keyboard II Overlay Generator
//
//  Created by Peter Hosey on 2008-05-04.
//  Copyright 2008 Peter Hosey. All rights reserved.
//

#import "NSObject+MapKVCKeysToDictionaryKeys.h"

@implementation NSObject (PRHMapKVCKeysToDictionaryKeys)

- (NSDictionary *)valuesForKeysWithKeyMapping:(NSDictionary *)keyMapping {
	NSMutableDictionary *result = [NSMutableDictionary dictionaryWithCapacity:[keyMapping count]];

	NSEnumerator *KVCKeysEnum = [keyMapping keyEnumerator];
	NSString *KVCKey;
	while ((KVCKey = [KVCKeysEnum nextObject])) {
		id obj = [self valueForKey:KVCKey];
		if (obj)
			[result setObject:obj forKey:[keyMapping objectForKey:KVCKey]];
	}

	return [[result copy] autorelease];
}

@end
